#include <bits/stdc++.h>

using namespace std;

int a[500000];

int main()
{
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);
    int n, k;
    cin >> n >> k;
    for(int i = 0; i < n; i++)
        cin >> a[i];
    int br = 0, pom = k;
    for(int i = 1; i < n; i++)
    {
        if(k <= 0)
            break;
        while(a[i] < a[br])
        {
            a[br] = -1;
            k--;
            br--;
            if(k <= 0)
                break;
            if(br == -1)
                break;

        }

        br = i;
    }
    int p = 0;
    for(int i = 0; i < n; i++)
    {
        if(p == n - pom)
            break;
        if(a[i] != -1)
        {
            p++;
            cout << a[i] << " ";
        }


    }
    return 0;
}